#include <stdio.h>

/*
  Implement sum() to sum a 2-D array of integers
    - using `goto` and labels
    - without using `for`, `while`, or `do`
    - with only one-armed `if`s
    - with only `goto` in the "then" part of `if`
*/

int sum(int **a, int len1, int len2)
{
  int sum = 0;
  int index1 = 0;
  int index2;

  /* Would be

     for (index2 = 0; index2 < len2; index2++)
       for (index1 = 0; index1 < len1; index1++)
         sum += a[index1][index2];
     
	 if we could use for loops... */

  index2 = 0;
 loop2:
  if (!(index2 < len2))
    goto done;

  index1 = 0;
 loop1:
  if (!(index1 < len1))
    goto inc2_and_loop2;

  sum += a[index1][index2];
  
  index1++;
  goto loop1;

 inc2_and_loop2:
  index2++;
  goto loop2;

 done:
  return sum;
}

int a0[] = {1, 2};
int a1[] = {5, 7};
int *a[2] = {a0, a1};

int main()
{
  int v = sum(a, 2, 2);

  printf("%d\n", v);

  return 0;
}
